#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: 01_vbq_network_init.pl, v1.0.0.0 Fri Jun  6 17:07:49 2008 mstauber Exp $
# Copyright 2007-2008 Solarspeed Ltd. All rights reserved.
#
# Script to populate CCE with the propper network settings under CCE. Without this
# every CCE restart would fuck up the routing and make this VPS unreachable.

use CCE;
#use Sys::Hostname;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

# Parse /etc/sysconfig/network-scripts/ifcfg-venet0
$venet_zero = '/etc/sysconfig/network-scripts/ifcfg-venet0';
if (-e $venet_zero) {
    open(FILE,"$venet_zero") || die("Could not find $venet_zero. $!");
    while ($line = <FILE>) {
        chomp($line);
        next if $line =~ /^\s*$/; # skip blank lines
        if ($line =~ /^IPADDR=(.*)/) {
            $ipaddress = $1;
        }
        if ($line =~ /^NETMASK=(.*)/) {
            $netmask = $1;
        }
    }
    close(FILE);
}

# Parse /etc/sysconfig/network
$nwfile = '/etc/sysconfig/network';
if (-e $nwfile) {
    open(NFILE,"$nwfile") || die("Could not find $nwfile. $!");
    while ($line = <NFILE>) {
        chomp($line);
        next if $line =~ /^\s*$/; # skip blank lines
        if ($line =~ /^GATEWAY=(.*)/) {
            $defaultgw = $1;
        }
        if ($line =~ /^GATEWAY=\"(.*)\"/) {
            $defaultgw = $1;
        }
    }
    close(NFILE);
}
if (($defaultgw == "") || (!$defaultgw)) {
	system("/bin/cat /etc/sysconfig/network |/bin/grep -v ^GATEWAY > /etc/sysconfig/network.bak");
	system("/bin/mv /etc/sysconfig/network.bak /etc/sysconfig/network");
	system("/bin/echo GATEWAY=\"192.0.2.1\" >> /etc/sysconfig/network");
	system("/etc/init.d/network restart > /dev/null");
}

# Get host and domain name: (not needed as long as we do not need/want to bypass wizard)
#$fqdn = hostname();
#(@fqdnparts) = split (/\./, $fqdn);
#$host = $fqdnparts[0];
#(@domainhelper) = split (/$host\./, $fqdn);
#$domain = $domainhelper[1];

# Parse /etc/resolv.conf
$rwfile = '/etc/resolv.conf';
if (-e $rwfile) {
    open(RFILE,"$rwfile") || die("Could not find $rwfile. $!");
    while ($line = <RFILE>) {
        chomp($line);
        next if $line =~ /^\s*$/; # skip blank lines
        if ($line =~ /^nameserver (.*)/) {
            $nameserver = $1;
        }
    }
    close(RFILE);
}

$cce->connectuds();

# Populate CCE with the new info:
($sys_oid) = $cce->find('Network', {'device' => 'venet0'});
if ($sys_oids < 0) {
    # Object 'System' not found in CCE, creating it:
    ($ok) = $cce->create('System', {
        'ipaddr' => $ipaddress,
        'netmask' => $netmask,
        'real' => "1",
        'device' => 'venet0'
    });
}
else {
    ($ok) = $cce->set($sys_oid, '',{
        'ipaddr' => $ipaddress,
        'netmask' => $netmask,
        'real' => "1",
        'device' => 'venet0'
    });
}
# Populate CCE with the new info:
($sys_oid) = $cce->find('Network', {'device' => 'venet0:0'});
if ($sys_oids < 0) {
    # Object not found in CCE
}
else {
    ($ok) = $cce->set($sys_oid, '',{
        'real' => "1"
    });
}

($sys_oid) = $cce->find('System', '');
if ($sys_oids < 0) {
    # Object 'System' not found in CCE, creating it:
    ($ok) = $cce->create('System', {
        'gateway' => $defaultgw
    });
}
else {
    ($ok) = $cce->set($sys_oid, '',{
        'gateway' => $defaultgw
    });
}

# Set the device of all CCE Objects "Disk" to /def/simfs:
(@sys_oid) = $cce->findx('Disk', '');
foreach $entry (@sys_oid) {
    ($ok) = $cce->set($entry, '',{
        'device' => '/dev/simfs'
    });
}

# Goodbye!
$cce->bye('SUCCESS');
exit(0);

